Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/create_okushiri.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/create_okushiri.py	(revision 4782)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/create_okushiri.py	(revision 4783)
@@ -145,10 +145,5 @@
 
 
-
-
-#-------------------------------------------------------------
-if __name__ == "__main__":
-
-
+def create_mesh(elevation_in_mesh=False):
     # Prepare time boundary
     prepare_timeboundary(project.boundary_filename)
@@ -165,3 +160,13 @@
                                  use_cache=False,
                                  verbose=True)
+    
+    if elevation_in_mesh is True:
+        fit_to_mesh_file(project.mesh_filename, project.bathymetry_filename,
+                         project.mesh_filename)
 
+
+#-------------------------------------------------------------
+if __name__ == "__main__":
+    create_mesh()
+
+
Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py	(revision 4782)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/run_okushiri.py	(revision 4783)
@@ -29,62 +29,68 @@
 import project
 
-
-#-------------------------
-# Create Domain from mesh
-#-------------------------
-domain = Domain(project.mesh_filename, use_cache=False, verbose=True)
-print domain.statistics()
+def main(elevation_in_mesh=False):
+    #-------------------------
+    # Create Domain from mesh
+    #-------------------------
+    domain = Domain(project.mesh_filename, use_cache=False, verbose=True)
+    print domain.statistics()
 
 
-#-------------------------
-# Initial Conditions
-#-------------------------
-domain.set_quantity('friction', 0.0)
-domain.set_quantity('stage', 0.0)
-domain.set_quantity('elevation',
-                    filename=project.bathymetry_filename,
-                    alpha=0.02,                    
-                    verbose=True,
-                    use_cache=False)
+    #-------------------------
+    # Initial Conditions
+    #-------------------------
+    domain.set_quantity('friction', 0.0)
+    domain.set_quantity('stage', 0.0)
+    if elevation_in_mesh is False:
+        domain.set_quantity('elevation',
+                            filename=project.bathymetry_filename,
+                            alpha=0.02,                    
+                            verbose=True,
+                            use_cache=False)
 
 
-#-------------------------
-# Set simulation parameters
-#-------------------------
-domain.set_name(project.output_filename)  # Name of output sww file
-domain.set_default_order(2)               # Apply second order scheme 
-domain.set_all_limiters(0.9)              # Max second order scheme (old lim)
-domain.set_minimum_storable_height(0.001) # Don't store w < 0.001m
-domain.set_maximum_allowed_speed(0.0)     # No runoff (though 0.1 is OK)
-domain.set_quantities_to_be_monitored('stage')
+    #-------------------------
+    # Set simulation parameters
+    #-------------------------
+    domain.set_name(project.output_filename)  # Name of output sww file
+    domain.set_default_order(2)               # Apply second order scheme 
+    domain.set_all_limiters(0.9)              # Max second order scheme
+                                              # (old lim)
+    domain.set_minimum_storable_height(0.001) # Don't store w < 0.001m
+    domain.set_maximum_allowed_speed(0.0)     # No runoff (though 0.1 is OK)
+    domain.set_quantities_to_be_monitored('stage')
 
-# New slope limiter and first order h-limiter
-# (this in planned to be the default!)
-domain.beta_h = 0.0
-domain.tight_slope_limiters = 1 # Run time invariant in this case
+    # New slope limiter and first order h-limiter
+    # (this in planned to be the default!)
+    domain.beta_h = 0.0
+    domain.tight_slope_limiters = 1 # Run time invariant in this case
 
-#-------------------------
-# Boundary Conditions
-#-------------------------
+    #-------------------------
+    # Boundary Conditions
+    #-------------------------
 
-# Create boundary function from timeseries provided in file
-function = file_function(project.boundary_filename,
-                         domain, verbose=True)
+    # Create boundary function from timeseries provided in file
+    function = file_function(project.boundary_filename,
+                             domain, verbose=True)
 
-# Create and assign boundary objects
-Bts = Transmissive_Momentum_Set_Stage_boundary(domain, function)
-Br = Reflective_boundary(domain)
-domain.set_boundary({'wave': Bts, 'wall': Br})
+    # Create and assign boundary objects
+    Bts = Transmissive_Momentum_Set_Stage_boundary(domain, function)
+    Br = Reflective_boundary(domain)
+    domain.set_boundary({'wave': Bts, 'wall': Br})
 
 
-#-------------------------
-# Evolve through time
-#-------------------------
-import time
-t0 = time.time()
+    #-------------------------
+    # Evolve through time
+    #-------------------------
+    import time
+    t0 = time.time()
 
-for t in domain.evolve(yieldstep = 0.05, finaltime = 22.5):
-    domain.write_time()
-    print domain.quantity_statistics(precision='%.12f')
+    for t in domain.evolve(yieldstep = 0.05, finaltime = 22.5):
+        domain.write_time()
+        print domain.quantity_statistics(precision='%.12f')
 
-print 'That took %.2f seconds' %(time.time()-t0)
+    print 'That took %.2f seconds' %(time.time()-t0)
+
+#-------------------------------------------------------------
+if __name__ == "__main__":
+    main()
Index: /anuga_validation/automated_validation_tests/okushiri_tank_validation/validate_okushiri.py
===================================================================
--- /anuga_validation/automated_validation_tests/okushiri_tank_validation/validate_okushiri.py	(revision 4782)
+++ /anuga_validation/automated_validation_tests/okushiri_tank_validation/validate_okushiri.py	(revision 4783)
@@ -9,10 +9,4 @@
 class Test_Okushiri(unittest.TestCase):
     def setUp(self):
-        pass
-        
-    def tearDown(self):
-        pass
-
-    def test_that_output_is_as_expected(self):
         
         # Remove garbage
@@ -23,4 +17,9 @@
                 os.remove(file)
                 
+        
+    def tearDown(self):
+        pass
+
+    def test_that_output_is_as_expected(self):
 
         #print
@@ -40,5 +39,24 @@
         assert res == 0
 
+    def manual_test_that_output_is_as_expected(self):
+        from run_okushiri import main
+        from create_okushiri import create_mesh
 
+        # Note, this has not been tested when code is failing.
+        # Next step, use the parrameter elevation_in_mesh
+        # and only run create_okishiri once for speed.
+        
+        res = create_mesh()
+        assert res == None
+        
+        res = main()
+        assert res == None
+        
+        s = 'compare_timeseries_with_measures.py'
+        #print s
+        res = os.system('python %s > compare_timeseries_with_measures.stdout'\
+                        %s)
+        assert res == 0
+        
 
 #-------------------------------------------------------------