Index: uga_core/source/anuga/anuga_config.py
===================================================================
--- /anuga_core/source/anuga/anuga_config.py	(revision 4836)
+++ 	(revision )
@@ -1,9 +1,0 @@
-"""Parameters knows across anuga model
-"""
-
-epsilon = 1.0e-12
-default_boundary_tag = 'exterior'
-
-# Major revision number for use with create_distribution
-# and update_anuga_user_guide
-major_revision = '1.0beta'
Index: /anuga_core/source/anuga/config.py
===================================================================
--- /anuga_core/source/anuga/config.py	(revision 4836)
+++ /anuga_core/source/anuga/config.py	(revision 4837)
@@ -1,48 +1,36 @@
-"""Module where global pyvolution model parameters are set
+"""Module where global ANUGA model parameters and default values are set
 """
 
-
-#FIXME (Ole): Temporary access to global config file
-from anuga_config import epsilon, default_boundary_tag
-
-#FIXME (Ole): More of these may need to be moved to anuga_config.py
-time_format = '%d/%m/%y %H:%M:%S'
-
-min_timestep = 1.0e-6 #Should be computed based on geometry
-max_timestep = 1.0e+3
-#This is how:
-#Define maximal possible speed in open water v_max, e.g. 500m/s (soundspeed?)
-#Then work out minimal internal distance in mesh r_min and set
-#min_timestep = r_min/v_max
-#
-#Max speeds are calculated in the flux function as
-#
-#lambda = v +/- sqrt(gh)
-#
-# so with 500 m/s, h ~ 500^2/g = 2500 m well out of the domain of the
-# shallow water wave equation
-#
-#The actual soundspeed can be as high as 1530m/s
-#(see http://staff.washington.edu/aganse/public.projects/clustering/clustering.html),
-#but that would only happen with h>225000m in this equation. Why ?
-#The maximal speed we specify is really related to the max speed
-#of surface pertubation
-#
+#--------------------
+# Numerical constants
+#--------------------
+epsilon = 1.0e-12 # Smallest number - used for safe division
+max_float = 1.0e36 # Largest number - used to initialise (max, min) ranges
 
 
-#v_max = 100 #For use in domain_ext.c
-sound_speed = 500
+#-------------------------------------------
+# Standard filenames, directories and system 
+# parameters used by ANUGA
+#-------------------------------------------
+pmesh_filename = '.\\pmesh'
+version_filename = 'stored_version_info.py'
+default_datadir = '.'
+time_format = '%d/%m/%y %H:%M:%S'
+umask = 002  # Controls file and directory permission created by anuga
+default_boundary_tag = 'exterior' 
+
+# Major revision number for use with create_distribution
+# and update_anuga_user_guide
+major_revision = '1.0beta'
 
 
-max_smallsteps = 50  #Max number of degenerate steps allowed b4 trying first order
-
-manning = 0.03  #Manning's friction coefficient
-#g = 9.80665       #Gravity
+#-------------------
+# Physical constants
+#-------------------
+manning = 0.03  # Manning's friction coefficient
+#g = 9.80665    # Gravity - FIXME reinstate this and fix unit tests.
 g = 9.8
 #g(phi) = 9780313 * (1 + 0.0053024 sin(phi)**2 - 0.000 0059 sin(2*phi)**2) micro m/s**2, where phi is the latitude
 #The 'official' average is 9.80665
-
-
-
 
 eta_w = 3.0e-3 #Wind stress coefficient
@@ -51,8 +39,13 @@
 
 
-#Betas [0;1] control the allowed steepness of gradient for second order
-#extrapolations. Values of 1 allow the steepes gradients while
-#lower values are more conservative. Values of 0 correspond to
-#1'st order extrapolations.
+#-----------------------------------------------------
+# Limiters - used with linear reconstruction of vertex 
+# values from centroid values
+#-----------------------------------------------------
+
+# Betas [0;1] control the allowed steepness of gradient for second order
+# extrapolations. Values of 1 allow the steepes gradients while
+# lower values are more conservative. Values of 0 correspond to
+# 1'st order extrapolations.
 #
 # Large values of beta_h may cause simulations to require more timesteps
@@ -67,10 +60,5 @@
 # Can you please let me know if you disagree?
 
-
-#There are separate betas for the w, uh, vh and h limiters
-#
-#Good values are:
-
-
+# There are separate betas for the w, uh, vh and h limiters
 # I think these are better SR but they conflict with the unit tests!
 beta_w      = 1.0
@@ -102,8 +90,10 @@
 
 
-CFL = 1.0  #FIXME (ole): Is this in use yet??
-           #(Steve) yes, change domain.CFL to
-           #make changes
+#-------------
+# Timestepping
+#-------------
 
+CFL = 1.0  # CFL condition assigned to domain.CFL - controls timestep size
+      
 # Choose type of timestepping,
 timestepping_method = 'euler' # 1st order euler
@@ -119,29 +109,42 @@
 protect_against_isolated_degenerate_timesteps = False
 
-pmesh_filename = '.\\pmesh'
-version_filename = 'stored_version_info.py'
+
+min_timestep = 1.0e-6 # Minimal timestep accepted in ANUGA
+max_timestep = 1.0e+3
+max_smallsteps = 50  # Max number of degenerate steps allowed b4 trying first order
+
+#Perhaps minimal timestep could be based on the geometry as follows:
+#Define maximal possible speed in open water v_max, e.g. 500m/s (soundspeed?)
+#Then work out minimal internal distance in mesh r_min and set
+#min_timestep = r_min/v_max
+#
+#Max speeds are calculated in the flux function as
+#
+#lambda = v +/- sqrt(gh)
+#
+# so with 500 m/s, h ~ 500^2/g = 2500 m well out of the domain of the
+# shallow water wave equation
+#
+#The actual soundspeed can be as high as 1530m/s
+#(see http://staff.washington.edu/aganse/public.projects/clustering/clustering.html),
+#but that would only happen with h>225000m in this equation. Why ?
+#The maximal speed we specify is really related to the max speed
+#of surface pertubation
+#
+#v_max = 100 #For use in domain_ext.c
+#sound_speed = 500
 
 
-import os, sys
+#---------------------------------------------------
+# Ranges specific to the shallow water wave equation
+# These control maximal and minimal values of 
+# quantities
+#---------------------------------------------------
 
-if sys.platform == 'win32':
-    default_datadir = '.'
-else:
-    default_datadir = '.'
+# Water depth below which it is considered to be 0 in the model
+minimum_allowed_height = 1.0e-3 
 
-
-use_extensions = True    #Try to use C-extensions
-#use_extensions = False   #Do not use C-extensions
-
-use_psyco = True  #Use psyco optimisations
-#use_psyco = False  #Do not use psyco optimisations
-
-
-optimise_dry_cells = True # Exclude dry and still cells from flux computation
-
-optimised_gradient_limiter = True # Use hardwired gradient limiter
-
-#Specific to shallow water W.E.
-minimum_allowed_height = 1.0e-3 #Water depth below which it is considered to be 0 in the model
+# Water depth below which it is *stored* as 0
+minimum_storable_height = 1.0e-5
 
 # FIXME (Ole): Redefine this parameter to control maximal speeds in general
@@ -151,15 +154,25 @@
                             # Too large (100) creates 'flopping' water
                             # Too small (0) creates 'creep'
+			    
+maximum_froude_number = 100.0 # To be used in limiters.
 
 
-maximum_froude_number = 100.0 # To be used in limiters.
+#------------------------------------------------------------
+# Performance parameters used to invoke various optimisations
+#------------------------------------------------------------
 
-minimum_storable_height = 1.0e-5 # Water depth below which it is *stored* as 0
+use_extensions = True # Use C-extensions
+use_psyco = True # Use psyco optimisations
+
+optimise_dry_cells = True # Exclude dry and still cells from flux computation
+optimised_gradient_limiter = True # Use hardwired gradient limiter
 
 points_file_block_line_size = 500 # Number of lines read in from a points file
                                   # when blocking
 
-umask = 002  # used to set file and directory permission created by anuga
 
-max_float = 1.0e36 # Largest number. Used to initialise (max, min) ranges.
+
+
+
+
     
Index: /create_distribution.py
===================================================================
--- /create_distribution.py	(revision 4836)
+++ /create_distribution.py	(revision 4837)
@@ -36,7 +36,4 @@
 
 
-# Define main version manually
-# major_revision = '1.0beta'
-
 # line separator 
 lsep = '----------------------------------------------------------------------'
@@ -54,5 +51,9 @@
 distro_filename = 'anuga-%s.tgz' %revision
 
-# Create area directory
+#-----------------------------------
+# Create directory for this release.
+# It will be named like
+#        anuga_release_1.0beta_4824
+#-----------------------------------
 release_dir = '~/anuga_release_%s' %revision 
 s = 'mkdir %s' %release_dir
@@ -63,6 +64,7 @@
     pass
 
-
-# Export a clean directory tree from the working copy to a temporary dir
+#-----------------------------------------------------
+# Create temporary area for svn to export source files
+#-----------------------------------------------------
 distro_dir = mktemp()
 s = 'mkdir %s' %distro_dir
@@ -70,6 +72,7 @@
 system(s)
 
-
-
+#--------------------------------
+# Get the ANUGA core source files
+#--------------------------------
 s = 'svn export -r %d anuga_core/source/anuga %s/anuga' %(svn_revision,
                                                           distro_dir) 
@@ -83,5 +86,5 @@
 #-----------------------------
 # Get validation_files as well
-
+#-----------------------------
 s = 'mkdir %s/anuga_validation' %distro_dir
 system(s)
@@ -93,8 +96,7 @@
 
 s = 'svn export anuga_validation/solitary_waves %s/anuga_validation/solitary_waves'\
-    %(distro_dir) 
-print s
-system(s)
-
+    %(distro_dir) p
+rint s
+system(s)
 
 s = 'svn export anuga_validation/automated_validation_tests %s/anuga_validation/automated_validation_tests'\
@@ -103,14 +105,10 @@
 system(s)
 
-
-# FIXME: Other validations in here!!!
-
-
-#-----------------------------
+# FIXME: Other validations in here as they appear!
+
+
+#---------------------------
 # Get demos from user manual
-
-#s = 'mkdir %s/anuga_demos' %distro_dir
-#system(s)
-
+#---------------------------
 s = 'svn export anuga_core/documentation/user_manual/demos %s/anuga_demos'\
     %(distro_dir) 
@@ -118,17 +116,21 @@
 system(s)
 
-
 #------------------
 # Zip everything up
+#------------------
 s = 'cd %s;tar cvfz %s *' %(distro_dir, distro_filename)
 print s
 system(s)
 
+#----------------------------
 # Move distro to release area
+#----------------------------
 s = '/bin/mv %s/*.tgz %s' %(distro_dir, release_dir) 
 print s
 system(s)
 
+#---------
 # Clean up
+#---------
 s = '/bin/rm -rf %s/*' %(distro_dir) 
 print s
@@ -141,10 +143,12 @@
 #-----------------------------
 # Copy and rename anuga_viewer
+#-----------------------------
 s = '/bin/cp ./anuga_core/source/anuga_viewer/distros/anuga_viewer_1.0.tgz %s/anuga_viewer-%s.tgz' %(distro_dir, revision)
 print s
 system(s)
 
-
+#----------------------------
 # Move viewer to release area
+#----------------------------
 s = '/bin/mv %s/*.tgz %s' %(distro_dir, release_dir) 
 print s
@@ -153,7 +157,7 @@
 
 
-#-----------------------------
-# Hey, why not compile and bundle up the LaTeX documentation as well 
-
+#----------------------------------------------
+# Compile and bundle up the LaTeX documentation 
+#----------------------------------------------
 print
 print lsep
@@ -178,6 +182,7 @@
 
 
-#-----------------------------
-
+#----------------------------
+# Print list of release files
+#----------------------------
 print 'Done'
 print
@@ -190,10 +195,12 @@
 print
 
+
+#-------------------------------------
+# Copy release to various destinations
+#-------------------------------------
 answer = raw_input('Do you want to upload this to sourceforge? Y/N [Y]')
 if answer.lower() != 'n':
     
-    #------------------------------
     print 'Uploading to sourceforge'
-
 
     import os, os.path
@@ -262,5 +269,4 @@
 
 
-    
     # Copy to the ANU
     #s = 'rsync -avz %s/* ole@datamining.anu.edu.au:public_html/software/anuga/%s' %(release_dir, 'anuga_%s' %revision)