Index: /anuga_core/documentation/user_manual/demos/cairns/runcairns.py
===================================================================
--- /anuga_core/documentation/user_manual/demos/cairns/runcairns.py	(revision 4837)
+++ /anuga_core/documentation/user_manual/demos/cairns/runcairns.py	(revision 4838)
@@ -95,6 +95,12 @@
 # Setup computational domain
 #------------------------------------------------------------------------------
-
-domain = Domain(meshname, use_cache=True, verbose=True)
+from anuga.abstract_2d_finite_volumes.pmesh2domain import pmesh_to_domain_instance
+from anuga.caching import cache
+
+##domain = cache(Domain(meshname, use_cache=True, verbose=True)
+
+domain = cache(pmesh_to_domain_instance,
+               (meshname, Domain),
+               dependencies = [meshname])
 
 print 'Number of triangles = ', len(domain)
@@ -112,4 +118,6 @@
 
 
+
+domain.points_file_block_line_size = 50000
 
 #------------------------------------------------------------------------------
Index: /anuga_core/source/anuga/fit_interpolate/fit.py
===================================================================
--- /anuga_core/source/anuga/fit_interpolate/fit.py	(revision 4837)
+++ /anuga_core/source/anuga/fit_interpolate/fit.py	(revision 4838)
@@ -41,5 +41,5 @@
 
 import exceptions
-class ToFewPointsError(exceptions.Exception): pass
+class TooFewPointsError(exceptions.Exception): pass
 class VertsWithNoTrianglesError(exceptions.Exception): pass
 
@@ -213,7 +213,7 @@
             self.D[v0,v2] += e20
 
-
     def get_D(self):
         return self.D.todense()
+
 
 
@@ -324,4 +324,5 @@
           
         """
+
         # use blocking to load in the point info
         if type(point_coordinates_or_filename) == types.StringType:
@@ -350,7 +351,8 @@
                     
                 # Build the array
+
                 points = geo_block.get_data_points(absolute=True)
                 z = geo_block.get_attributes(attribute_name=attribute_name)
-                self.build_fit_subset(points, z)
+                self.build_fit_subset(points, z, verbose=verbose)
 
                 
@@ -379,5 +381,5 @@
             msg += 'Alternatively, set smoothing parameter alpha to a small '
 	    msg += 'positive value,\ne.g. 1.0e-3.'
-            raise ToFewPointsError(msg)
+            raise TooFewPointsError(msg)
 
         self._build_coefficient_matrix_B(verbose)
@@ -545,4 +547,5 @@
     # Caching happens at the higher level anyway.
     
+
     if mesh is None:
         # FIXME(DSG): Throw errors if triangles or vertex_coordinates
Index: /anuga_core/source/anuga/fit_interpolate/test_fit.py
===================================================================
--- /anuga_core/source/anuga/fit_interpolate/test_fit.py	(revision 4837)
+++ /anuga_core/source/anuga/fit_interpolate/test_fit.py	(revision 4838)
@@ -549,5 +549,5 @@
         try:
             f = interp.fit(data_points,z)
-        except ToFewPointsError:
+        except TooFewPointsError:
             pass
 
Index: /anuga_validation/convergence_study/animatesww2d_alt.py
===================================================================
--- /anuga_validation/convergence_study/animatesww2d_alt.py	(revision 4837)
+++ /anuga_validation/convergence_study/animatesww2d_alt.py	(revision 4838)
@@ -104,5 +104,5 @@
     max_stage = max(max(max_stages))
     stage_axis = [0, max_x, min_stage-1, max_stage+1]
-    from pylab import plot, xlabel, ylabel, savefig, close, hold, axis, title
+    from pylab import plot, xlabel, ylabel, savefig, close, hold, axis, title,show
     hold(False)
     figs = []
@@ -110,5 +110,6 @@
     #max_vec = zeros(100, Float)
 
-    if sys.platform == 'win32':
+    #if sys.platform == 'win32':
+    try:
         for i in range(0,n,20):
             #max_vec[i] = max(stage[i,:])
@@ -121,4 +122,8 @@
             title(name)
             figs.append(name)
+            show()
+    except:
+        pass
+    
 
     close('all')
Index: /anuga_validation/convergence_study/convergence_structured.py
===================================================================
--- /anuga_validation/convergence_study/convergence_structured.py	(revision 4837)
+++ /anuga_validation/convergence_study/convergence_structured.py	(revision 4838)
@@ -23,8 +23,8 @@
 # Setup computational domain
 #------------------------------------------------------------------------------
-dx = 200.
+dx = 100.
 dy = dx
 L = 100000.
-W = 3000.
+W = dx
 
 # structured mesh
@@ -35,6 +35,6 @@
 #points, vertices, boundary = rectangular_cross(1000, 100, 20, 3) # Basic mesh
 domain = Domain(points, vertices, boundary) 
-domain.set_timestepping_method('rk2')
-domain.set_default_order(2)
+
+
 ## # unstructured mesh
 ## poly_domain = [[0,-W],[0,W],[L,W],[L,-W]]
@@ -50,6 +50,17 @@
 ## # Create domain
 ## domain = Domain(meshname, use_cache=True, verbose = True)
-domain.set_name('myexample6')                
+
+domain.set_timestepping_method('euler')
+domain.set_default_order(2)
+domain.set_name('myexample9')                
 domain.set_datadir('.')                     # Use current directory for output
+
+domain.beta_w      = 100.0
+domain.beta_w_dry  = 0.2
+domain.beta_uh     = 100.0
+domain.beta_uh_dry = 0.2
+domain.beta_vh     = 100.0
+domain.beta_vh_dry = 0.2
+domain.beta_h      = 100.0
 
 #------------------------------------------------------------------------------
@@ -83,10 +94,11 @@
 domain.set_boundary({'left': Bw, 'right': Bt, 'top': Br, 'bottom': Br})
 
-#from anuga.visualiser import RealtimeVisualiser
-#vis = RealtimeVisualiser(domain)
-#vis.render_quantity_height("elevation", dynamic=False)
-#vis.render_quantity_height("stage", dynamic=True)
-#vis.colour_height_quantity('stage', (0.0, 0.0, 0.8))
-#vis.start()
+## from anuga.visualiser import RealtimeVisualiser
+## vis = RealtimeVisualiser(domain)
+## vis.render_quantity_height("elevation", dynamic=False)
+## vis.render_quantity_height("stage", dynamic=True, zScale=100.0)
+## #vis.colour_height_quantity('stage', (0.0, 0.0, 0.8))
+## vis.colour_height_quantity('stage', (lambda q:q['stage'], -1, 1))
+## vis.start()
 
 #------------------------------------------------------------------------------